import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopChatConversation, ShopChatConversationParam } from './model';

/**
 * 分页查询聊天会话表
 */
export async function pageShopChatConversation(params: ShopChatConversationParam) {
  const res = await request.get<ApiResult<PageResult<ShopChatConversation>>>(
    '/shop/shop-chat-conversation/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询聊天会话表列表
 */
export async function listShopChatConversation(params?: ShopChatConversationParam) {
  const res = await request.get<ApiResult<ShopChatConversation[]>>(
    '/shop/shop-chat-conversation',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加聊天会话表
 */
export async function addShopChatConversation(data: ShopChatConversation) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-chat-conversation',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改聊天会话表
 */
export async function updateShopChatConversation(data: ShopChatConversation) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-chat-conversation',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除聊天会话表
 */
export async function removeShopChatConversation(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-chat-conversation/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除聊天会话表
 */
export async function removeShopBatchChatConversation(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-chat-conversation/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询聊天会话表
 */
export async function getShopChatConversation(id: number) {
  const res = await request.get<ApiResult<ShopChatConversation>>(
    '/shop/shop-chat-conversation/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
